// binasm.cpp : Defines the entry point for the console application.
//



#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define DEC  (0)
#define HEX1 (1)
#define HEX2 (2)
#define BYTE (1)
#define HWORD (2)
#define WORD (3)

int main(int argc, char *argv[])
{
	int size;
	int format;
	char prefix[10];
	bool isC;
	int i;

	// defaults...
	size 		= 1;
	format      = HEX2;
	isC			= false;
    strcpy(prefix,".byte");

	for (i=1;i<argc;i++)
	{
		 if (argv[i][0]=='-')
		 {
			  switch(argv[i][1])
			  {
					case 's': case 'S':

						size = atoi(argv[i+1]);
						i++;

					break;

					case 'f': case 'F':

						if
							(strcmpi(argv[i+1],"dec")==0) format = DEC;
						else if
							(strcmpi(argv[i+1],"$")==0) format = HEX1;
						else if
							(strcmpi(argv[i+1],"0x")==0) format = HEX2;
						else
							{printf("illegal switch operand -f...\n"); return 0;}

						i++;

					break;

					case 'p': case 'P':

						 strcpy(prefix,argv[i+1]);

                   i++;
				   break;

				   case 'c': case 'C':
					isC=true;
				   break;
			  }
		 }
	}

	if (isC)
	{
		if (format==HEX1) format=HEX2;	// cannot be $
		strcpy(prefix,"none");				
	}
	

	printf("\nformat = %d",format);
	printf("\nprefix = %s",prefix);
	printf("\nsize = %d",size);

	FILE *in  = NULL;
	FILE *out = NULL;

	in  = fopen(argv[1],"rb");
	out = fopen(argv[2],"wt");

	if ((in == NULL) || (out == NULL)){ printf("\nerror opening files...\n"); return 0;}


	unsigned long data;
	int count = 0;

	if (isC)
	{
		switch(size)
		{
			case 2: fprintf(out,"unsigned short "); break;
			case 4: fprintf(out,"unsigned long "); break;
			default: fprintf(out,"unsigned char "); break;
		}

		fprintf(out," data[] = { \n");
	}

	for (;;)
	{
		 if (!(count%10))
		 {
			if (isC) fprintf(out,"\n");
			else fprintf(out,"\n%s ",prefix);
		 }

		 switch(size)
		 {

				case 2:  
					data = (getc(in) | (getc(in)<<8)); 
				break;
				
				case 4:  
					data = (getc(in) | (getc(in)<<8) | (getc(in)<<16) | (getc(in)<<24));
				break;
				
				
				default: 
					data = getc(in); 
				break;

		 }

		if (feof(in)) break;


		 switch(format)
		 {
			case DEC: 	
				fprintf(out,"%d,",data); 
			break;
			
			case HEX1:  
				switch(size)
				{
					case 2:			fprintf(out,"$%.4X,",data); break; 
					case 4:			fprintf(out,"$%.8X,",data); break; 
					default:		fprintf(out,"$%.2X,",data); break; 
				}
			 
			break;
			
			case HEX2:  
				switch(size)
				{
					case 2:			fprintf(out,"0x%.4X,",data); break; 
					case 4:			fprintf(out,"0x%.8X,",data); break; 
					default:		fprintf(out,"0x%.2X,",data); break; 
				}
					
			break;
			 
		 }


		 count++;


	}
	
	if (isC) fprintf(out,"};\n\n");


	fclose(in);
	fclose(out);

	printf("\n%d items assembled",count);
	printf("\nHave a nice day & visit www.goldroad.co.uk");
	printf("\n- foolsgold");

	return 0;
}

//   foolsgold www.goldroad.co.uk
